<template>
  <div class="p-4 pb-20 min-h-[calc(50vh-72px)]">
    <ul v-if="initPromotions.length" id="promotion-list">
      <promotion-card
        :promotions="initPromotions"
        :on-click-spin-now="onClickSpinNow"
        :validateLuckyWheelbutton="validateLuckyWheelbutton"
      />
    </ul>
    <no-data
      v-else
      empty-text="no_promotion_info"
      :hash-text="assignHashText"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, ref, provide } from "vue";
import PromotionCard from "./components/promotion-card.client.vue";
import NoData from "./components/no-data.client.vue";
import { Promotion } from "@/models/promotion/promotion";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";

export default defineComponent({
  name: "Promotion",
  components: {
    PromotionCard,
    NoData,
  },
  setup() {
    const { getAssetImage } = commonHelper;
    const { auth, currency } = store.state;
    const {
      promotions,
      onApplyPromotion,
      assignHashText,
      validateLuckyWheelbutton,
      onClickSpinNow,
    } = usePromotion();
    const dialogVisible = ref(false);

    const initPromotions = computed(() => {
      if (promotions.value.length < 1) {
        return [];
      }
      return promotions.value.map((p) => new Promotion(p));
    });
    provide("onApplyPromotion", onApplyPromotion);

    return {
      initPromotions,
      getAssetImage,
      auth,
      currency,
      dialogVisible,
      assignHashText,
      validateLuckyWheelbutton,
      onClickSpinNow,
    };
  },
});
</script>

<style scoped lang="scss">
#promotion-list {
  @apply flex max-w-[1160px] flex-wrap;
}
</style>
